#include <bits/stdc++.h>

using namespace std;

int main(int argc, char** argv) {
	int n,c,q;
	cin>>n;
	cin>>c;
	cin>>q;	
	int l[q];
	int r[q];
	char s[n];
	int nula=0;
	int m[q];
	int y;
	int y1;
	int jedan=0;
	for(int i=0;i<n;i++)
	{
		cin>>s[i];
		if(s[i]=='0') nula++;
	}
	int h=0;
	jedan=n-nula;
	int nula1=0;
	for(int i=0;i<q;i++)
	{	
		cin>>l[i];
		cin>>r[i];
		for(int j=l[i]-1;j<r[i];j++)
		{
			if(s[j]=='0') 
			{
				nula--;
				jedan++;
				s[j]='1';
			}
			else if(s[j]=='1')
			{
				nula++;
				jedan--;
				s[j]='0';
			}
		}
			for(int l=0;l<n;l++)
			{
				if(s[l]=='1') 
				{
				y=l;
				break;
				}
			}
			for(int v=n-1;v>=0;v--)
			{
				if(s[v]=='1')
				{
					y1=v; 
					break; 
				}
			}
			nula1=nula-y-(n-1-y1);
			if((c+nula1)<jedan)
			{
					m[h]=c+nula1;
					h++;
			}
			else 
			{
				m[h]=jedan;
				h++;	
			}
			
	}
	for(int i=0;i<h;i++)
	{
		cout<<m[i];
		cout<<endl;
	}
	return 0;
}